"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mapCanvasBlendModesToPixi;

var _const = require("../../../const");

var _canUseNewCanvasBlendModes = _interopRequireDefault(require("./canUseNewCanvasBlendModes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapCanvasBlendModesToPixi(array) {
  if (array === void 0) {
    array = [];
  }

  if ((0, _canUseNewCanvasBlendModes.default)()) {
    array[_const.BLEND_MODES.NORMAL] = "source-over";
    array[_const.BLEND_MODES.ADD] = "lighter"; // IS THIS OK???

    array[_const.BLEND_MODES.MULTIPLY] = "multiply";
    array[_const.BLEND_MODES.SCREEN] = "screen";
    array[_const.BLEND_MODES.OVERLAY] = "overlay";
    array[_const.BLEND_MODES.DARKEN] = "darken";
    array[_const.BLEND_MODES.LIGHTEN] = "lighten";
    array[_const.BLEND_MODES.COLOR_DODGE] = "color-dodge";
    array[_const.BLEND_MODES.COLOR_BURN] = "color-burn";
    array[_const.BLEND_MODES.HARD_LIGHT] = "hard-light";
    array[_const.BLEND_MODES.SOFT_LIGHT] = "soft-light";
    array[_const.BLEND_MODES.DIFFERENCE] = "difference";
    array[_const.BLEND_MODES.EXCLUSION] = "exclusion";
    array[_const.BLEND_MODES.HUE] = "hue";
    array[_const.BLEND_MODES.SATURATION] = "saturate";
    array[_const.BLEND_MODES.COLOR] = "color";
    array[_const.BLEND_MODES.LUMINOSITY] = "luminosity";
  } else {
    // this means that the browser does not support the cool new blend modes in canvas 'cough' ie 'cough'
    array[_const.BLEND_MODES.NORMAL] = "source-over";
    array[_const.BLEND_MODES.ADD] = "lighter"; // IS THIS OK???

    array[_const.BLEND_MODES.MULTIPLY] = "source-over";
    array[_const.BLEND_MODES.SCREEN] = "source-over";
    array[_const.BLEND_MODES.OVERLAY] = "source-over";
    array[_const.BLEND_MODES.DARKEN] = "source-over";
    array[_const.BLEND_MODES.LIGHTEN] = "source-over";
    array[_const.BLEND_MODES.COLOR_DODGE] = "source-over";
    array[_const.BLEND_MODES.COLOR_BURN] = "source-over";
    array[_const.BLEND_MODES.HARD_LIGHT] = "source-over";
    array[_const.BLEND_MODES.SOFT_LIGHT] = "source-over";
    array[_const.BLEND_MODES.DIFFERENCE] = "source-over";
    array[_const.BLEND_MODES.EXCLUSION] = "source-over";
    array[_const.BLEND_MODES.HUE] = "source-over";
    array[_const.BLEND_MODES.SATURATION] = "source-over";
    array[_const.BLEND_MODES.COLOR] = "source-over";
    array[_const.BLEND_MODES.LUMINOSITY] = "source-over";
  } // not-premultiplied, only for webgl


  array[_const.BLEND_MODES.NORMAL_NPM] = array[_const.BLEND_MODES.NORMAL];
  array[_const.BLEND_MODES.ADD_NPM] = array[_const.BLEND_MODES.ADD];
  array[_const.BLEND_MODES.SCREEN_NPM] = array[_const.BLEND_MODES.SCREEN];
  return array;
}
//# sourceMappingURL=mapCanvasBlendModesToPixi.js.map